audio = {
	volume = 1,
	squawk = function(src, p, v) -- play a sound
		if not sfx[src] then return end
		local pitch = p or 1
		local volume = v or 1
		local source = sfx[src]:clone()
		source:setPitch(pitch)
		source:setVolume(volume)
		table.insert(sfxlist, source)
		love.audio.play(source)
	end;
	multisquawk = function(tbl, p, v) -- play a sound
		if not tbl then return end
		src = tbl[math.floor(love.math.random(#tbl))]
		if not sfx[src] then return end
		local pitch = p or 1
		local volume = v or 1
		local source = sfx[src]:clone()
		source:setPitch(pitch)
		source:setVolume(volume)
		table.insert(sfxlist, source)
		love.audio.play(source)
	end;
	stream = function(channel, src, l, p, v) -- play stream
		if not stream[src] then return end
		local loop = l or true
		local pitch = p or 1
		local volume = v or 1
		local source = stream[src]:clone()
		source:setLooping(loop)
		if streamlist[channel] then streamlist[channel]:stop() end
		streamlist[channel] = source
		if not str_channel[channel] then audio.new_channel(channel) end
		str_channel[channel].pitch = pitch
		str_channel[channel].volume = volume
		love.audio.play(source)
	end;
	new_channel = function(channel)
		str_channel[channel] = { volume = 1, pitch = 1 }
	end;
	set_volume = function(tgt, duration) -- change master volume w/ tweening
		if duration then
			timer.tween(duration, audio, {volume = tgt})
		else
			audio.volume = tgt
		end
	end;
	stream_volume = function(channel, tgt, duration, stop)
		if not str_channel[channel] then return end
		if not streamlist[channel] then return end
		if duration and stop then
			timer.tween(duration, str_channel[channel], {volume=tgt}, "linear", streamlist[channel]:stop())
		elseif duration then
			timer.tween(duration, str_channel[channel], {volume=tgt})
		else
			str_channel[channel].volume = tgt
		end
	end;	
	stream_playing = function(channel)
		if not streamlist[channel] then return false end
		if not streamlist[channel]:isPlaying() then return false
		else return true end
	end;
	stream_stop = function(channel)
		if not streamlist[channel] then return end
		streamlist[channel]:stop()
	end;
	stream_pitch = function(channel, tgt, duration)
		if not str_channel[channel] then return end
		if duration then
			timer.tween(duration, str_channel[channel], {pitch=tgt})
		else
			str_channel[channel].pitch = tgt
		end
	end;
}