-- fantastic magic superclass
thing = class {
	init = function(self, x, y, z, w, h)
		self.class = "thing"
		self.tag = {}
		self.pos = { x = x or 0, y = y or 0, z = z or 0 }
		self.prev_pos = { x = self.pos.x, y = self.pos.y, z = self.pos.z }
		self.vel = { x = 0, y = 0, z = 0 }
		self.offset = { x=0, y=0, z=0 }
		self.size = { w = w or 16, h = h or 16 } -- basic bounding box
		self.scale = 1
		self.angle = 0
		self.z = 0 -- z is used in drawlist sorting
		self.marked_for_death = false
		--self.cell = { x = 1, y = 1 }
		self.colour = {r = 255, g = 255, b = 255, a = 255}
	end;
	draw = function(self, _edit)
		love.graphics.setLineStyle("rough")
		love.graphics.setColor(255, 0, 0)
		love.graphics.rectangle("fill", self.pos.x, self.pos.y, self.size.w, self.size.h)
		love.graphics.setColor(255, 255, 255)
		love.graphics.rectangle("line", self.pos.x, self.pos.y, self.size.w, self.size.h)
		love.graphics.line(self.pos.x-8, self.pos.y, self.pos.x+8, self.pos.y)
		love.graphics.line(self.pos.x, self.pos.y-8, self.pos.x, self.pos.y+8)
	end;
	contains = function(self, x, y)
		return within(x, y, self.pos.x, self.pos.y, self.pos.x+self.size.w, self.pos.y+self.size.h)
	end;
	move = function(self, dt)

		self.prev_pos.x, self.prev_pos.y, self.prev_pos.z = self.pos.x, self.pos.y, self.pos.z
		self.pos.x = self.pos.x + self.vel.x * dt
		self.pos.y = self.pos.y + self.vel.y * dt
		self.pos.z = self.pos.z + self.vel.z * dt

	end;

	bounce = function(self)
		local bounced = false
		if self.pos.x < 0 or self.pos.x > love.graphics.getWidth() then self.vel.x = -self.vel.x self:angle_from_vel() bounced = true end
		if self.pos.y < 0 or self.pos.y > love.graphics.getHeight() then self.vel.y = -self.vel.y self:angle_from_vel() bounced = true end
		if bounced then
			self.angle = math.atan2(self.vel.y, self.vel.x)
		end
		return bounced
	end;

	angle_from_vel = function(self)
		self.angle = math.atan2(self.vel.y, self.vel.x)
		--self.vel.x = math.cos(angle) * self.vel.x
		--self.vel.y = math.sin(angle) * self.vel.y
	end;
	thrust = function(self, speed, angle)
		local angle = angle or self.angle
		local speed = speed or 100
		self.vel.x = math.cos(angle) * speed
		self.vel.y = math.sin(angle) * speed
	end;
	offscreen = function(self)
		if self.pos.x < 0 or self.pos.y < 0 or self.pos.x > love.graphics.getWidth() or self.pos.y > love.graphics.getHeight() then return true end
	end;
	update = function(self, dt)
		self:move(dt)
	end;
	destroy = function(self)
		self.marked_for_death = true
	end;
}
