animation = class {
	init = function(self, image, w, h, frames, looping)

		self.looping = looping
		self.frame = frames

		self.image = gfx[image]
		self.quad = slice(image, w, h, 0)

		self:start()

	end;

	start = function(self)

		self.direction = "forward"
		self.mirrored = false
		self.sound_played = false
		self.time = 0
		self.current_frame = 1
		self.speed = 1
		self.paused = false

	end;

	draw = function(self, x, y, r, sx, sy, ox, oy, kx, ky)

		love.graphics.draw(self.image, self.quad[self.current_frame], x, y, r, sx, sy, ox, oy, kx, ky)

	end;

	update = function(self, dt)

		if self.paused then return end

		if self.frame[self.current_frame].sound and not self.sound_played then
			audio.squawk(self.frame[self.current_frame].sound)
			self.sound_played = true
		end

		self.time = self.time + dt
		if self.time > self.frame[self.current_frame].delay * self.speed then
			if self.direction == "forward" then
				self.current_frame = self.current_frame + 1
				self.time = 0
				self.sound_played = false
			elseif self.direction == "backwards" then
				self.current_frame = self.current_frame - 1
				self.time = 0
				self.sound_played = false
			end
		end

		if self.looping == true then
			if self.current_frame > #self.frame then
				self.current_frame = 1
			elseif self.current_frame < 1 then
				self.current_frame = #self.frame
			end
		elseif self.looping == "pingpong" then
			if self.current_frame > #self.frame then
				self.current_frame = #self.frame - 1
				self.direction = "backwards"
			elseif self.current_frame < 1 then
				self.current_frame = 2
				self.direction = "forward"
			end
		else
			if self.current_frame > #self.frame then
				self.sound_played = true
				self.current_frame = #self.frame
			elseif self.current_frame < 1 then
				self.sound_played = true
				self.current_frame = 1
			end
		end

	end;
}