-- player flyer
fx_thrust = class {

	__includes = thing,

	init = function(self, x, y, z, speed, angle, size, curl)
		thing.init(self, x, y, z, 0, 0)
		local a = things[1].alpha
		self.speed = speed --* love.math.random(1, 2) * 0.5 --love.math.random(100, 400)
		self.angle = angle
		self.curl = love.math.random(-curl, curl)
		self.size = love.math.random(size, size*3)
		self.colour = things[1].colour:lighten_by(1)
		self.alpha = things[1].alpha
		self.points = {self.pos.x, self.pos.y}
	end;

	draw = function(self)

		if self.marked_for_death then return end

		col = {}
		col.r, col.g, col.b = colour.hsl_to_rgb(self.colour.H, self.colour.S, self.colour.L)
		love.graphics.setCanvas(canvas)
		local xx, yy = self.pos.x+love.math.random(-3, 3), self.pos.y+love.math.random(-3, 3)
		love.graphics.setColor(col.r*255, col.g*255, col.b*255, self.alpha)
		love.graphics.circle("fill", xx, yy, self.size)
		love.graphics.setCanvas()

	end;

	update = function(self, dt)

		if self:offscreen() then self:destroy() end

		self.size = self.size - 10*dt
		self.speed = self.speed - 100*dt --(100+math.abs(love.math.random(self.curl*0.5,self.curl))) * dt
		if self.speed <= 0 or self.size <= 0 then self:destroy() end

		--self.angle = self.angle + self.curl * dt--love.math.random(0, self.curl) * dt

		self:thrust(-self.speed)
		self:move(dt)

		table.insert(self.points, self.pos.x)
		table.insert(self.points, self.pos.y)

	end;

}