-- player flyer
player = class {

	__includes = thing,

	init = function(self, x, y, z, w, h)
		thing.init(self, x, y, z, w, h)
		self.turn_speed = 5
		self.thrust_level = 0
		self.thrust_max = 500
		self.accel = 100
		self.muffle = false
		self.alpha = 255
		self.alpha2 = 255
		self.sat = 1
		self.lit = 0.5
		self.warp_buildup = 0
		self.fire_sfx = true
		--self.p = 255

		self.timer = timer.new()

		--self.timer:every(5, function() self.timer:tween(5, self.colour, {S=love.math.random()}) end)

		self.shoot_mode = 1
		self.shoot_modes = {
			{ drunk = 0.1, spread = 0, name = "focused mode" },
			{ drunk = 0.25, spread = 30, name = "spread mode" },
			{ drunk = 15, spread = 1, name = "drunk mode" },
			{ drunk = 90, spread = 0, name = "experimental mode" }
		}

		self.alpha_mode = 1
		self.alpha_modes = {
			{ alpha = 255, alpha2 = 255, name = "regular mode"},
			{ alpha = 100, alpha2 = 10, name = "reduced mode"},
			{ alpha = 15, alpha2 = 1, name = "eco mode"}
		}

		self.palette = {
			colour.new(0, 0, 0),
			colour.new(0, 0, 1),
			colour.new(0, 1, 0.5),
			colour.new(60, 1, 0.5),
			colour.new(120, 1, 0.5),
			colour.new(180, 1, 0.5),
			colour.new(240, 1, 0.5),
			colour.new(300, 1, 0.5),
			colour.new(0, 0, 0.5),
			colour.new(0, 0, 0)
		}


		self.colour = self.palette[3]

	end;

	draw = function(self)

		local col = {}
		col.r, col.g, col.b = colour.hsl_to_rgb(self.colour.H, self.colour.S, self.colour.L)
		love.graphics.setColor(col.r*255, col.g*255, col.b*255)
		--love.graphics.setLineStyle("rough")


		--love.graphics.line(self.pos.x-8, self.pos.y, self.pos.x+8, self.pos.y)
		--love.graphics.line(self.pos.x, self.pos.y-8, self.pos.x, self.pos.y+8)

		love.graphics.push()
		love.graphics.translate(self.pos.x, self.pos.y)
		love.graphics.rotate(self.angle)
		--love.graphics.setColor(0, 0, 0)
		love.graphics.polygon("fill", -8, -8, -8, 8, 8, 0)
		love.graphics.setColor(255, 255, 255)
		love.graphics.setLineWidth(3)
		love.graphics.polygon("line", -8, -8, -8, 8, 8, 0)
		love.graphics.setColor(0, 0, 0)
		love.graphics.setLineWidth(1)
		love.graphics.polygon("line", -8, -8, -8, 8, 8, 0)
		love.graphics.pop()
		love.graphics.setStencilTest()



	end;

	update = function(self, dt)

		self.timer:update(dt)

		self.palette[10].H = love.math.random(360)
		self.palette[10].S = love.math.random()
		self.palette[10].L = love.math.random()

		--self.colour.H = self.colour.H + 10 * dt

		local thrust_max = self.thrust_max
		if controller.states.turbo then 
			thrust_max = self.thrust_max * 2
		 	self.thrust_level = math.min(self.thrust_level+self.accel*dt, thrust_max)
		elseif controller.states.up then self.thrust_level = math.min(self.thrust_level+self.accel*dt, thrust_max)
		elseif controller.states.down then self.thrust_level = math.max(self.thrust_level-self.accel*dt, 0)
		end

		if self.thrust_level > thrust_max then self.thrust_level = self.thrust_level - self.accel*dt end

		if controller.states.left then self.angle = self.angle - self.turn_speed * dt
		elseif controller.states.right then self.angle = self.angle + self.turn_speed * dt
		end

		local mode = self.shoot_modes[self.shoot_mode]
		local angle = self.angle + math.rad(love.math.random(-mode.spread, mode.spread))

		if controller.states.fire then 
			if self.fire_sfx then
				audio.multisquawk({"cannon1", "cannon2", "cannon3"}, 1+love.math.random(1)*0.5)
				self.fire_sfx = false
				self.timer:after(0.15, function() self.fire_sfx = true end)
			end
			table.insert(things, missile(self.pos.x, self.pos.y, self.pos.z, self.thrust_level+100, angle, mode.drunk)) 
		end

		if controller.states.hue then 
			--self.colour = self.colour:hue_offset(10*dt) 
			self.colour.H = self.colour.H + 120 * dt
			if self.colour.H > 360 then
				self.colour.H = self.colour.H - 360
			end
			audio.stream_pitch(3, 0.5+(math.abs((self.colour.H-180))/180))
			audio.stream_volume(3, 1)
		else
			--stream_volume = function(channel, tgt, duration, stop)
			audio.stream_volume(3, 0)
		end
		
		if controller.states.saturation then 
			self.sat = self.sat + dt * 0.33
			if self.sat > 1 then
				self.sat = -1
			end
			self.colour.S = math.abs(self.sat)
			audio.stream_pitch(1, 0.5+self.colour.S)
			audio.stream_volume(1, 1)
		else
			audio.stream_volume(1, 0)
		end	

		if controller.states.lightness then 
			self.lit = self.lit + dt * 0.33
			if self.lit > 1 then
				self.lit = -1
			end
			self.colour.L = math.abs(self.lit)
			audio.stream_pitch(2, 0.5+self.colour.L)
			audio.stream_volume(2, 0.5)
		else
			audio.stream_volume(2, 0)
		end

		if controller.tap.clear then
			local col = {}
			col.r, col.g, col.b = colour.hsl_to_rgb(self.colour.H, self.colour.S, self.colour.L)
			love.graphics.setCanvas(canvas_final)
			love.graphics.clear(col.r*255, col.g*255, col.b*255)
			love.graphics.setCanvas()
			audio.multisquawk({"warp1", "warp2", "warp3"})
		end

		if controller.states.warp then
			self.warp_buildup = self.warp_buildup + dt
		end

		self.angle = self.angle + love.math.random(-self.warp_buildup, self.warp_buildup) * 0.05

		if controller.tap.warp then 
			self.pos.x = love.math.random(love.graphics.getWidth())
			self.pos.y = love.math.random(love.graphics.getHeight())
			self.thrust_level = 0
			self.warp_buildup = 0
			audio.multisquawk({"warp1", "warp2", "warp3"})
			--self.angle = math.rad(love.math.random(360))
			--table.insert(things, splosio(self.pos.x, self.pos.y, self.pos.z)) 
		end

		if controller.tap.mode then
			self.shoot_mode = self.shoot_mode + 1
			if self.shoot_mode > #self.shoot_modes then self.shoot_mode = 1 end
			local mode = self.shoot_modes[self.shoot_mode]
			set_message("blomby cannon: " .. mode.name)
			audio.multisquawk({"select1", "select2", "select3"})
		end

		if controller.tap.power then
			self.alpha_mode = self.alpha_mode + 1
			if self.alpha_mode > #self.alpha_modes then self.alpha_mode = 1 end
			local mode = self.alpha_modes[self.alpha_mode]
			self.alpha = mode.alpha
			self.alpha2 = mode.alpha2
			set_message("power: " .. mode.name)
			audio.multisquawk({"select1", "select2", "select3"})
		end

		-- this is stupid
		if controller.tap.col_black then self.colour = self.palette[1] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_white then self.colour = self.palette[2] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_red then self.colour = self.palette[3] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_yellow then self.colour = self.palette[4] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_green then self.colour = self.palette[5] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_cyan then self.colour = self.palette[6] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_blue then self.colour = self.palette[7] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_magenta then self.colour = self.palette[8] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_grey then self.colour = self.palette[9] audio.multisquawk({"select1", "select2", "select3"})
		elseif controller.tap.col_wild then self.colour = self.palette[10] audio.multisquawk({"select1", "select2", "select3"}) set_message("warning: unstable energy crystal")
		end

		if controller.tap.muffle then 
			self.muffle = not self.muffle 
			if self.muffle then set_message("megamuffler: muffling")
			else set_message("megamuffler: not muffling")
			end
			audio.multisquawk({"select1", "select2", "select3"})
		end

		self:thrust(self.thrust_level)
		if self.thrust_level > 1 and not self.muffle then
			local col = {}
			local thrust = self.thrust_level +  love.math.random(-self.warp_buildup, self.warp_buildup) * 200
			table.insert(things, fx_thrust(self.pos.x, self.pos.y, self.pos.z, thrust, self.angle, 1, 333))
		end

		self:move(dt)
		if self:bounce() then audio.multisquawk({"bigbounce1", "bigbounce2", "bigbounce3"}) end

	end;

}